
system.require('std/core/repeatingTimer.em');

var BANKNAME = 'bankTest';
var BANKPWORD = 'password';

if (typeof(bankConnection) !== 'undefined') {
	bankConnection.create(BANKNAME,BANKPWORD, function() {});
	var bankPinger = function() {
		system.__debugPrint('PINGING BANK');
		{action: 'updatePing'} >> bankConnection.service >> [];
	};
	
	var pingTimer =new std.core.RepeatingTimer(5, bankPinger);
}
clientRequest << {'action':'touch':};

var connectHandlers = [];

function clientRequest(msg, client) {

	
	  function handleClient () {
	    
		var serLoginSetup = false;
		var serLoginGUI;
		var serBankUI = @sirikata.ui(
		'serviceBankLogin',
		function() {
		  
			$('<div id="serBankLogin-ui" title="Bank Connect">' +
			'  <div id="serBankCheck"/>' +
				'  <div id="serBankIntro"/>' +
				'  <input value="" id="bankUserName"></input>' +
			  '  <button id="serBLogin-button">Enter</button>' +

			  
			  '</div>').appendTo('body');

			var window = new sirikata.ui.window(                  
			   "#serBankLogin-ui",
			   {
				  width: 100,
				  height: 'auto'
			   }
			);
			window.show();

			sirikata.ui.button('#serBLogin-button').click(loginBankCheck);  
			$('#serBankIntro').text('Please login to your bank account then enter your bank username here.  This will cost 10 neo shekels.');
            
			function loginBankCheck() {	
                var bUsername = ($('#bankUserName').val());	
				window.toggle();
				sirikata.event('check', bUsername);
			}
			bankCheckStatus = function(message, success) {
				if (!success) {
					window.toggle();
					$('#serBankIntro').text('Sorry, invalid bank username. Please login to your bank account then enter your bank username here.  This will cost 10 neo shekels.');
				}
			};
			openSerLogin = function() {
				window.toggle();
			};
			
		}
	);@;

	var respListener;
	
	serBGUIfunc = function (gui) {
		system.__debugPrint('opening GUI for client');
		serLoginGUI = gui;
		gui.bind("check", std.core.bind(bankAcctCheck,this));
		serLoginSetup = true;
	};
	updateBCheck = function (msg) {
			if (typeof(msg.success) !=='undefined' && msg.success === true) {
				serLoginGUI.call('bankCheckStatus', msg.result,true);
			} else
				serLoginGUI.call('bankCheckStatus',msg.result,false);
	};
	function bankAcctCheck(username) {
		bankUserN = username;
		{check: username}>>system.createVisible(serviceServerStr)>>[];
		respListener = updateBCheck<<{'bankCheck'::}<<system.createVisible(serviceServerStr);
	}
	if (!serLoginSetup)
		simulator._simulator.addGUITextModule("serviceBankLogin", serBankUI, std.core.bind(serBGUIfunc, this));
	else
		serLoginGUI.call('openSerLogin');

	  }
	  
	  //A few lines appended around handleClient.  
	  var serviceServerStr = 'var serviceServerStr ="' + system.self.toString() + '"; \n';

	  
	  //This line is necessary to actually call handleClient on the client side.
	  var handleString = serviceServerStr + handleClient.toString() + "\n handleClient();";
	  
	  
	  var request = {
            request : 'script',
            script : handleString
        };

		request >> client >> [];	
	  

	  
	  checkBankAcct << {'check'::} << client;
	}
	function checkBankAcct(msg, sender) {
		{action: 'checkUser', pres: sender.toString(), username: msg.check}>>bankConnection.service >> [std.core.bind(initTrade,this,sender.toString(),msg.check), 5, function() {}];
	}
	function initTrade(client,username,msg, bank) {
		var resp = new Object();
		resp.bankCheck = true;
		if (typeof(msg.success) !== 'undefined' && msg.success === true) {
			resp.success = true;
			resp.result = 'Successfully logged in to bank account.  Agree to the trade transaction fee of 10 neo shekels please.';
			bankConnection.trade([{type: 'string', value: 'some service'}], [{type: 'money', value: 10}], username, std.core.bind(feeResponse,this, client), std.core.bind(feeResponse,this, client), false);
		} else {	
			resp.failure = true;
			resp.result = 'Failed to login successfully.';
		}		
		resp >> system.createVisible(client) >> [];
	}
	function feeResponse(client,result) {
		if (result === 'approved') {
			//DO STUFF
		} else {
			//CLIENT REJECTED TRADE
		}
	}